/*
    BASE.CFM
    This custom form is the "base" form for the 
     dB2K tutorial project. The purpose of
    this form is to give something that all the other
    forms are "based" on. Any changes to this form
    will alter the derived forms, including colors,
    and such.

*/
** END HEADER -- do not remove this line
class baseCForm of FORM custom
   with (this)
      onGotFocus = class::FORM_ONGOTFOCUS
      onLostFocus = class::FORM_ONLOSTFOCUS
      canClose = class::FORM_CANCLOSE
      scaleFontBold = false
      height = 11.7727
      left = 69.2857
      top = 0.1818
      width = 46.8571
      text = "BaseForm"
      menuFile = "DiveMenu.mnu"
      icon = "resource #210"
   endwith


   function form_canClose
      // is there a rowset associated with the form? And
      // if so, is the state set to edit or beginAppend?
      if form.rowset # NULL and;
         (form.rowset.state == 2 or form.rowset.state == 3)
         // if so, is the rowset modified?
         if form.rowset.modified
            nAnswer = msgbox("Save changes before leaving record?", "Data has changed",32+3)
            do case
               case nAnswer == 6
                  form.rowset.save()
               case nAnswer == 7
                  form.rowset.abandon()
               otherwise
                  return false
            endcase
         endif
      endif
  
      
      return true

   function form_onGotFocus
      // set application reference to this form:

      if type( "_app.myApp" ) # "U"
         _app.myApp.currentForm = this
         //_app.framewin.currentForm = this
      endif

      form.repaint()
   return

   function form_onLostFocus
      // null out application's reference to this form:
      if type( "_app.myApp.currentForm" ) # "U"
         _app.myApp.currentForm := null
      endif

   return

   function Repaint
      parameter oForm
      if type( "oForm" ) == "U" or empty( oForm )
         oForm = form
      endif
      if type( "UpdateWindow" ) # "FP"
         extern CLOGICAL UpdateWindow( CHANDLE ) USER32
      endif
   RETURN UpdateWindow( oForm.hWnd )
endclass
